@ECHO OFF
chcp 650001
SETLOCAL
echo "** CONVERSOR DE CERTIFICADO PARA O BANCO INTER **"
echo %~dp0
REM Desenvolvido por L2 SOLUCOES TECNOLOGICAS LTDA - www.l2s.com.br
set BASE_DIR=%~dp0

REM FIXO
set OPENSSL_CONF=%BASE_DIR%\BIN\openssl.cnf
set OPENSSL=%BASE_DIR%\BIN\openssl.exe
set PATH=%BASE_DIR%\BIN\;%PATH%


REM Variaveis informada pelo usurio
set CNPJ=
set SENHA=
set EMAIL=
set KEYFILE=
set CRTFILE=



REM Comandos
:MENU
set COMANDO=
echo Digite uma das opes:
echo " 'PFX' - Para converter o *.CRT + *.KEY em *.PFX;"
echo " 'FIM' - Para sair deste programa."
set /P COMANDO="Digite PFX ou FIM para prosseguir: "
IF "%COMANDO%" == "PFX" GOTO GERARPFX
IF "%COMANDO%" == "FIM" GOTO FIM
GOTO USOINCORRETO



:GERARPFX
set /P CNPJ="Digite o CNPJ do titular da conta (Somente nmeros): "
IF "%CNPJ%" == "" GOTO USOINCORRETO
set PFXFILE=%~dp0CERTIFICADOS\%CNPJ%.pfx

set /P KEYFILE="Digite o caminho completo do arquivo *.KEY: "
IF "%KEYFILE%" == "" GOTO USOINCORRETO

set /P CRTFILE="Digite o caminho completo do arquivo *.CRT: "
IF "%CRTFILE%" == "" GOTO USOINCORRETO

set /P SENHA="Digite a SENHA do CERTIFICADO: "
IF "%SENHA%" == "" GOTO USOINCORRETO




IF EXIST %KEYFILE% (
  GOTO VERIFICACRT
)
ECHO "Arquivo KEY no encontrado: "%KEYFILE%". Informe o caminho completo do e tente novamente.
timeout /t 30
GOTO MENU

:VERIFICACRT
IF EXIST %CRTFILE% (
  GOTO CRIARPFX
)

echo Arquivo "%CRTFILE%" no encontrado. Informe o caminho completo do e tente novamente.
timeout /t 30
GOTO MENU

:CRIARPFX
echo ""
echo ===============================================================================================================================================
echo Chave privada (*.KEY)          : %KEYFILE%
echo Certificado (*.CRT)            : %CRTFILE%
echo Arquivo com certificado (*.PFX): %PFXFILE%
echo ===============================================================================================================================================
echo ""
echo Gerando o PFX...

%OPENSSL% pkcs12 -export -in "%CRTFILE%" -inkey "%KEYFILE%" -out "%PFXFILE%" -passout pass:%SENHA%

set PFXFILE2=%~dp0CERTIFICADOS\%CNPJ%-LEGADO.pfx
%OPENSSL% pkcs12 -export -in "%CRTFILE%" -inkey "%KEYFILE%" -out "%PFXFILE2%" -passout pass:%SENHA% -legacy -provider-path %BASE_DIR%\BIN\

set PFXFILE3=%~dp0CERTIFICADOS\%CNPJ%-3DES.pfx
%OPENSSL% pkcs12 -export -in "%CRTFILE%" -inkey "%KEYFILE%" -out "%PFXFILE3%" -passout pass:%SENHA% -descert

set PFXFILE4=%~dp0CERTIFICADOS\%CNPJ%-AES256.pfx
%OPENSSL% pkcs12 -export -in "%CRTFILE%" -inkey "%KEYFILE%" -out "%PFXFILE4%" -passout pass:%SENHA% -aes256

echo Arquivo PFX gerado em: %PFXFILE%
GOTO FIM

:USOINCORRETO
echo "Dados incorretos."
timeout /t 60
GOTO MENU

:FIM
ECHO "FIM!"
timeout /t 90